version: "3"

networks:
  internal:
    driver: bridge

services:

  web:
    build:
      context: ./
      dockerfile: Dockerfile.nginx
    command: dockerize -wait tcp://app:3000 nginx -g 'daemon off;'
    ports: ["::1:443:443"]
    volumes:
      - "./nginx.conf:/etc/nginx/nginx.conf"
      - "./dhparams.pem:/etc/ssl/dhparams.pem"
      - "./src/doc/development/api.example.net.crt:/etc/nginx/certs/api.example.net.crt"
      - "./src/doc/development/api.example.net.key:/etc/nginx/certs/api.example.net.key"
    depends_on: ["app"]
    networks: ["internal"]

  app:
    build: .
    user: "1000:1000"
    command: dockerize -wait tcp://postgres:5432 bundle exec rails s -p 3000 -b '0.0.0.0'
    ports: ["::1:3000:3000"]
    env_file: ["./app.env"]
    volumes:
      - ./src:/usr/src/app
    depends_on: ["postgres"]
    networks: ["internal"]

  postgres:
    image: mdillon/postgis:11-alpine
    env_file: ["postgres.env"]
    volumes: ["./.state/postgis-data:/var/lib/postgresql/data"]
    networks: ["internal"]
